/*****************************************************************************
 *          DigRUN: a minimal interpreter for educational purpose            *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2015 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include "interpreter.h"

//Interface with Flex & Bison
extern FILE *yyin;              //from Flex
extern int yyparse(void);       //from Bison

int main(int argc, char** argv)
{
  if(argc < 2)
    {
      printf("usage: digrun file.asm [-debug]\n");
      exit(1);
    }

  init();

  yyin = fopen(argv[1],"r");
  if(yyin == 0)
    {
      printf("Error: file cannot be opened\n");
      exit(1);
    }

  int bison_return_code = yyparse();

  fix_labels();
  if(argc > 2)
    exec_code(1);
  else
    exec_code(0);

  //print_symbols();
}
